Package org.codehaus.groovy.ast

# Class GenericsType

java.lang.Object
org.codehaus.groovy.ast.ASTNode
org.codehaus.groovy.ast.GenericsType

public class GenericsType extends ASTNode
This class is used to describe generic type signatures for ClassNodes.

Author:
  Jochen Theodorou
See Also:
  - `ClassNode`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final GenericsType[]`
`EMPTY_ARRAY`

## Constructor Summary

Constructors
Constructor
Description
`GenericsType(ClassNode basicType)`
`GenericsType(ClassNode type, ClassNode[] upperBounds, ClassNode lowerBound)`

## Method Summary

Modifier and Type
Method
Description
`ClassNode`
`getLowerBound()`
`String`
`getName()`
`ClassNode`
`getType()`
`ClassNode[]`
`getUpperBounds()`
`boolean`
`isCompatibleWith(ClassNode classNode)`
Tells if the provided class node is compatible with this generic type definition
`boolean`
`isPlaceholder()`
`boolean`
`isResolved()`
`boolean`
`isWildcard()`
`void`
`setName(String name)`
`void`
`setPlaceholder(boolean placeholder)`
`void`
`setResolved(boolean res)`
`void`
`setType(ClassNode type)`
`void`
`setWildcard(boolean wildcard)`
`String`
`toString()`

### Methods inherited from class org.codehaus.groovy.ast.ASTNode

`copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getNodeMetaData, getNodeMetaData, getText, putNodeMetaData, removeNodeMetaData, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setNodeMetaData, setSourcePosition, visit`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### EMPTY_ARRAY

public static final GenericsType[] EMPTY_ARRAY

## Constructor Details

### GenericsType

public GenericsType(ClassNode type, ClassNode[] upperBounds, ClassNode lowerBound)

### GenericsType

public GenericsType(ClassNode basicType)

## Method Details

### getType

public ClassNode getType()

### setType

public void setType(ClassNode type)

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### getUpperBounds

public ClassNode[] getUpperBounds()

### getName

public String getName()

### isPlaceholder

public boolean isPlaceholder()

### setPlaceholder

public void setPlaceholder(boolean placeholder)

### isResolved

public boolean isResolved()

### setResolved

public void setResolved(boolean res)

### setName

public void setName(String name)

### isWildcard

public boolean isWildcard()

### setWildcard

public void setWildcard(boolean wildcard)

### getLowerBound

public ClassNode getLowerBound()

### isCompatibleWith

public boolean isCompatibleWith(ClassNode classNode)
Tells if the provided class node is compatible with this generic type definition

Parameters:
  `classNode` - the class node to be checked
Returns:
  true if the class node is compatible with this generics type definition